//CFTTFile_PAK - [2020-04-13 11:57:46]
#ifndef _CFTTFILE_PAK_H_
#define _CFTTFILE_PAK_H_

#include "CFTTFile.h"
#include "CFTTFileSystem_PAK.h"

/*
00221A9C	CFTTFile_PAK::CFTTFile_PAK(CFTTFileSystem_PAK* pFileSystem_PAK,TFTTPakFile const* pPakFile)
00221ADC	CFTTFile_PAK::~CFTTFile_PAK()
00221AF0	CFTTFile_PAK::~CFTTFile_PAK()
00221AF4	CFTTFile_PAK::Read(void *,long long)
00221BE8	CFTTFile_PAK::Write(void const*,long long)
00221BF6	CFTTFile_PAK::GetPos()
00221C0E	CFTTFile_PAK::Seek(long long,int)
00221C54	CFTTFile_PAK::GetAttributes()
00221C58	CFTTFile_PAK::Close()
00221C60	CFTTFile_PAK::IsOpen()
00221C6A	CFTTFile_PAK::GetAsyncHandler()
00221C74	CFTTFile_PAK::GetModeFlags()

_ZN12CFTTFile_PAKC2EP18CFTTFileSystem_PAKPK11TFTTPakFilej13EFTTMemHeapID

vptr_CFTTFile_PAK_3287C4:
  CFTTFile_PAK::~CFTTFile_PAK()
  CFTTFile_PAK::~CFTTFile_PAK()
  CFTTFile_PAK::Read(void *,long long)
  CFTTFile_PAK::Write(void const*,long long)
  CFTTFile_PAK::GetPos()
  CFTTFile_PAK::Seek(long long,int)
  CFTTFile_PAK::GetAttributes()
  CFTTFile_PAK::Close()
  CFTTFile_PAK::IsOpen()
  CFTTFile::ReadAsync(void *,long long,long long,void *,CFTTAsyncEvent<TFTTFileAsyncEventData> *)
  CFTTFile::WriteAsync(void const*,long long,long long,void *,CFTTAsyncEvent<TFTTFileAsyncEventData> *)
  CFTTFile_PAK::GetAsyncHandler()
  CFTTFile_PAK::GetModeFlags()
  CFTTFile::GetMemoryMappedPos()
  CFTTFile::UseBufferedAccess()
  CFTTFile::RequestFlushWrites()

0x28
*/

class CFTTFile_PAK : public CFTTFile {
public:
  CFTTFile_PAK(CFTTFileSystem_PAK *pFileSystem_PAK,
               TFTTPakFile const *pPakFile,
               uint,
               EFTTMemHeapID);                         //00221A9C
  virtual ~CFTTFile_PAK();                             //00221ADC 00221AF0
  virtual int64 Read(void *buf, int64 buflen);         //00221AF4
  virtual int64 Write(void const *buf, int64 buflen);  //00221BE8
  virtual int64 GetPos();                              //00221BF6
  virtual int64 Seek(int64 dpos, int whence);          //00221C0E
  virtual TFTTFileAttributes *GetAttributes();         //00221C54
  virtual bool Close();                                //00221C58
  virtual bool IsOpen();                               //00221C60
  virtual CFTTFile_AsyncHandler *GetAsyncHandler();    //00221C6A
  virtual int GetModeFlags();                          //00221C74

  TFTTPakFile *pPakFile_8;
  int mod_C;
  CFTTFileSystem_PAK *pFileSystem_PAK_10;
  int32_t unuse_14;
  TFTTFileAttributes attr_18;  //这行代码确定此处是 TFTTFileAttributes .text:00221C54   ADDS R0, #0x18
};

#endif  //_CFTTFILE_PAK_H_